﻿plugin.SetFlags(gddPluginFlagNone, gddContentFlagHaveDetails);

var 
  refresh_interval = 2;
  wrong_password = -1;
  wrong_password_item = null;
  setup_item = null;
  inbox_items = [];
  update_inbox_items = false;
  domains = [];

var 
  gmail_url = "https://gmail.google.com/gmail/feed/atom";
  gmail_inbox = "http://mail.google.com";

var
  emails = new Array();

var
  mainProfile;

utils.setInterval(OnTimer, 1000 * 60 * refresh_interval);

function view_onOpen()
{
  plugin.onAddCustomMenuItems = AddCustomMenuItems;
  plugin.onShowOptionsDlg = ShowOptions;  
  LoadProfile();
  StartFetch();
}

function AddCustomMenuItems(menu)
{
  menu.AddItem(REFRESH_MENU, 0, Refresh);
}

function StartFetch()
{
  wrong_password = -1;
  update_inbox_items = false;
  FetchAll(false); // for some reasons in async mode responses comes with wrong requests in multiple accounts mode
}

function OnTimer()
{
  StartFetch();
}

function Refresh()
{
  StartFetch();
}

function inbox_DetailsView(item, inbox_url)
{
  ShowPage(inbox_url);
  return null;
}

function options_DetailsView(item)
{
  plugin.ShowOptionsDialog();
  Refresh();
  return null;
}

function ClearAll()
{
  emails.length = 0;
  wrong_password_item = null;
  setup_item = null;
  inbox_items = [];
  cnArea.removeAllContentItems();
}

function FetchAll(async)
{
  if (mainProfile.userList.length == 0)
  {
    UpdateContentArea();
  }
  else
  {
    for(var i = 0; i < mainProfile.userList.length; i++)
    {
      FetchOne(async, i);
    }
    if (!async)
      UpdateContentArea();
  }
}

function FetchOne(async, profileIndex)
{
  if (profileIndex < mainProfile.userList.length)
  {
    var userInfo = mainProfile.userList[profileIndex];
    var user = userInfo.name;
    if (userInfo.domain != "")
      user = user + "@" + userInfo.domain;
    var pwd = userInfo.password;
    if (user != "")
    {
      var httpReq = new XMLHttpRequest();
      if (async)
        httpReq.onreadystatechange = function() { OnRssFeed(httpReq, profileIndex, true); };
      httpReq.open("POST", gmail_url, async, user, pwd);
      httpReq.send();
      if (!async)
        OnRssFeed(httpReq, profileIndex, false);
    }
  }
}

function AddInboxItems()
{
  var inbox_item;
  for (var i = 0; i < inbox_items.length; i++)
  {
    inbox_item = inbox_items[i];
    cnArea.RemoveContentItem(inbox_item);
  }
  inbox_items = [];
  for (var i = 0; i < domains.length; i++)
  {
    var domain = domains[i];
    inbox_item = new ContentItem();
    inbox_item.flags = gddContentItemFlagNoRemove + gddContentItemFlagPinned;
    if (domain == "")
    {
      inbox_item.heading = INBOX;
      inbox_item.onDetailsView = function() { inbox_DetailsView(inbox_item, gmail_inbox) };
    }
    else
    {
      inbox_item.heading = INBOX + " - " + domain;
      inbox_item.onDetailsView = function() { inbox_DetailsView(inbox_item, gmail_inbox + "/a/" + domain) };
    }
    cnArea.AddContentItem(inbox_item, gddItemDisplayInSidebar);
    inbox_items.push(inbox_item);
  }
  update_inbox_items = false;
}

function OnRssFeed(httpReq, profileIndex, updateArea)
{
  if ((httpReq != null) && (httpReq.readyState == 4))
  {
    if (httpReq.Status == 200)
    {
      var doc = httpReq.responseXML;
      var feedElement = doc.documentElement;
      if (feedElement == null)
        return;
      var title = "";
      for (var node = feedElement.firstChild; node != null; node = node.nextSibling)
      {
        if (node.nodeName == "title")
        {
          title = node.text;
          break;
        }
      }
      var entries = feedElement.getElementsByTagName("entry");
      var currentEmails = new Array();
      for (var i = entries.length - 1; i >= 0; i--)
      {
        var entry = entries[i];
        var currentId = "";
        for (var node = entry.firstChild; node != null; node = node.nextSibling)
        {
          if (node.nodeName == "id")
            currentId = node.text;
        }
        if (currentId != "")
        {
          currentEmails.push(currentId);
          var found = false;
          for (var j = 0; j < emails.length; j++)
          {
            var tempEmailInfo = emails[j];
            if (tempEmailInfo.id == currentId)
            {
              found = true;
              break;
            } 
          }
          if (!found)
          {
            var emailInfo = new EmailInfo();
            emailInfo.contentItem = new ContentItem();
            emailInfo.id = currentId;
            emailInfo.profileIndex = profileIndex;
            for (var node = entry.firstChild; node != null; node = node.nextSibling)
            {
              if (node.nodeName == "title")
                emailInfo.contentItem.heading = node.text;
              else if (node.nodeName == "link")
                emailInfo.contentItem.open_command = node.getAttribute("href");
              else if (node.nodeName == "summary")
                emailInfo.contentItem.snippet = node.text;
              else if (node.nodeName == "modified")
                emailInfo.contentItem.time_created = ParseDate(node.text).getVarDate();
              else if (node.nodeName == "author")
              {
                for (var sourceNode = node.firstChild; sourceNode != null; sourceNode = sourceNode.nextSibling)
                {
                  if (sourceNode.nodeName == "name")
                    emailInfo.contentItem.source = sourceNode.text;
                  else if (sourceNode.nodeName == "email")
                  {
                    if (emailInfo.contentItem.source == "")
                      emailInfo.contentItem.source = sourceNode.text;
                  }
                }
              }
            }
            if (mainProfile.userList.length > 1)
            {
              var userInfo = mainProfile.userList[profileIndex];
              if (userInfo.alias != "")
                emailInfo.contentItem.source = userInfo.alias + "\\" + emailInfo.contentItem.source;
            }
            AddEmailToList(emailInfo);
          }
        }
      } // for entries
      for (var i = emails.length - 1; i >= 0; i--)
      {
        var emailInfo = emails[i];
        if (emailInfo.profileIndex == profileIndex)
        {
          var found = false;
          for (var j = 0; j < currentEmails.length; j++)
          {
            if (currentEmails[j] == emailInfo.id)
            {
              found = true;
              break;
            }
          }
          if (!found)
          {
            RemoveEmailFromList(i);
          }
        }
      }
    }
    else if (httpReq.Status == 401)
    {
      debug.error("Wrong password");
      wrong_password = profileIndex;
    }
  }
  if (updateArea)
    UpdateContentArea();
}

function AddEmailToList(emailInfo)
{
  emails.push(emailInfo);
  emailInfo.contentItem.layout = gddContentItemLayoutEmail;
  emailInfo.contentItem.flags = gddContentItemFlagNoRemove + gddContentItemFlagHighlighted;
  cnArea.AddContentItem(emailInfo.contentItem, gddItemDisplayAsNotification + gddItemDisplayInSidebar);
//  cnArea.AddContentItem(emailInfo.contentItem, gddItemDisplayInSidebar);
  update_inbox_items = true;
}

function RemoveEmailFromList(index)
{
  var emailInfo = emails[index];
  if (emailInfo.contentItem != null)
  {
    cnArea.RemoveContentItem(emailInfo.contentItem);
    emailInfo.contentItem = null;
  }
  for (var i = index; i < emails.length - 1; i++)
    emails[i] = emails[i + 1];
  emails.length = emails.length - 1;
}

function UpdateContentArea()
{
  if ((mainProfile.userList.length == 0) || (wrong_password >= 0))
  {
    cnArea.removeAllContentItems();
    setup_item = null;
    wrong_password_item = null;
    inbox_items = [];
    var cItem = null;
    if ((mainProfile.userList.length == 0) || (wrong_password >= 0))
    {
      if (mainProfile.userList.length == 0) 
      {
        cItem = new ContentItem();
        cItem.heading = SET_USER;
        cItem.onDetailsView = options_DetailsView;
        setup_item = cItem;
      }
      else if ((wrong_password >= 0) && (wrong_password < mainProfile.userList.length))
      {
        cItem = new ContentItem();
        var userInfo = mainProfile.userList[wrong_password];
        cItem.heading = WRONG_PASSWORD_MSG + " " + userInfo.name;
        cItem.onDetailsView = options_DetailsView;
        wrong_password_item = cItem;
      }
    }
    if (cItem != null)
    {
      cItem.flags = gddContentItemFlagNoRemove + gddContentItemFlagPinned;
      cnArea.AddContentItem(cItem, gddItemDisplayInSidebar);
    }
  }
  else
  {
    if (wrong_password_item != null)
    {
      cnArea.RemoveContentItem(wrong_password_item);
      wrong_password_item = null;
    }
    if (setup_item != null)
    {
      cnArea.RemoveContentItem(setup_item);
      setup_item = null;
    }
    if ((inbox_items.length == 0) || update_inbox_items)
      AddInboxItems();
  }
}

function ShowPage(url) 
{
  var wshShell = new ActiveXObject("WScript.Shell");
  wshShell.run(url);
  wshShell = null;
}

function ShowOptions(window) {
  var options = new Options(OnOptionsOK, mainProfile.clone());
  options.show(window);
}

function OnOptionsOK(profile) {
  SaveProfile(profile);
  LoadProfile();
  ClearAll();
  StartFetch();
}

function LoadProfile()
{
  mainProfile = new Profile();
  domains = [];
  var userCount = options.getValue("UsersCount");
  if (userCount == '')
    userCount = 1;
  for (var i = 0; i < userCount; i++)
  {
    var userParam = "User";
    var passwordParam = "Pwd";
    var aliasParam = "Alias";
    var domainParam = "Domain";
    if (i > 0)
    {
      userParam += i;
      passwordParam += i;
      aliasParam += i;
      domainParam += i;
    }
    var user = options.getValue(userParam);
    if (user != '')
    {
      var password = options.getValue(passwordParam);
      var alias = options.getValue(aliasParam);
      var domain = options.getValue(domainParam);
      if (domain == null)
        domain = "";
      var userInfo = new UserInfo(user, password, domain);
      userInfo.alias = alias;
      mainProfile.userList.push(userInfo);
      var found = false;
      for (var j = 0; j < domains.length; j++)
        if (domains[j].toUpperCase() == domain.toUpperCase())
        {
          found = true;
          break;
        }
      if (!found)
        domains.push(domain);
    }
  }
}

function SaveProfile(profile)
{
  options.putValue("UsersCount", profile.userList.length);
  for (var i = 0; i < profile.userList.length; i++)
  {
    var userParam = "User";
    var passwordParam = "Pwd";
    var aliasParam = "Alias";
    var domainParam = "Domain";
    if (i > 0)
    {
      userParam += i;
      passwordParam += i;
      aliasParam += i;
      domainParam += i;
    }
    var userInfo = profile.userList[i];
    options.putValue(userParam, userInfo.name);
    options.putValue(passwordParam, userInfo.password);
    options.putValue(aliasParam, userInfo.alias);
    options.putValue(domainParam, userInfo.domain);
  }
}

function ParseDate(value)
{
  d = new Date();
  d.setFullYear(parseInt(value.substr(0, 4), 10));
  d.setMonth(parseInt(value.substr(5, 2), 10) - 1);
  d.setDate(parseInt(value.substr(8, 2), 10));

  d.setHours(value.substr(11, 2)); 
  d.setMinutes(value.substr(14, 2)); 
  d.setSeconds(value.substr(17, 2)); 

  return d;
}
