﻿function Options(onOK, profile)
{
  this.onOK = onOK;
  this.profile = profile;
}

Options.prototype.show = function(window) {
  // To use in anon functions
  var me = this;

  window.onClose = function (window, code){
    return me.onClose(window, code)
  }

  this.window = window;

  window.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", strings.USER_NAME_LABEL, 10, 10, 150, 20);

  this.userNameControl = window.AddControl(gddWndCtrlClassEdit, gddWndCtrlTypeNone, "userName", "", 10, 25, 150, 20);
  this.userNameControl.Text = options.GetValue("User");
  this.onChanged = function (window, control){
    return me.onUserChanged(window, control)
  }

  window.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", strings.PWD_LABEL, 10, 50, 150, 20);

  this.pwdControl = window.AddControl(gddWndCtrlClassEdit, gddWndCtrlTypeEditPassword, "pwd", "", 10, 65, 150, 20);
  this.pwdControl.Text = options.GetValue("Pwd");

  window.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", strings.DOMAIN_LABEL, 10, 90, 150, 20);

  this.domainControl = window.AddControl(gddWndCtrlClassEdit, gddWndCtrlTypeNone, "domain", "", 10, 105, 150, 20);
  this.domainControl.Text = options.GetValue("Domain");

  window.AddControl(gddWndCtrlClassLabel, gddWndCtrlTypeNone, "", strings.ALIAS_LABEL, 10, 130, 150, 20);

  this.aliasControl = window.AddControl(gddWndCtrlClassEdit, gddWndCtrlTypeNone, "alias", "", 10, 145, 150, 20);
  this.aliasControl.Text = options.GetValue("Alias");


  this.addButton = window.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonPush, "addUser", strings.Add, 170, 175, 100, 20);
  this.addButton.onClicked = function (window, control) {
    return me.onAddClicked(window, control)
  }

  this.addButton = window.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonPush, "removeUser", strings.Remove, 170, 200, 100, 20);
  this.addButton.onClicked = function (window, control) {
    return me.onRemoveClicked(window, control)
  }
  
  this.accountList = window.AddControl(gddWndCtrlClassList,  gddWndCtrlTypeListOpen, "accountList", [], 10, 175, 150, 145);
  this.accountList.onChanged = function (window, control) {
    return me.onAccountListChanged(window, control)
  }
  this.updateAccountList();
}

Options.prototype.onClose = function(window, code) {
  if (code == gddIdOK)
  {
    this.addAccount();
    this.saveUsers();
    this.onOK(this.profile);
  }
  return true;
}

Options.prototype.saveUsers = function()
{
}

Options.prototype.onUserChanged = function(window, control){
}

Options.prototype.onAddClicked = function(window, control){
  this.addAccount();
}

Options.prototype.onAccountListChanged = function(window, control)
{
  var userName = this.accountList.value;
  var userInfo = null;
  var found = false;
  for (var i = 0; i < this.profile.userList.length; i++)
  {
    userInfo = this.profile.userList[i];
    var name = userInfo.name;
    if (userInfo.domain != "") 
      name = name + "@" + userInfo.domain;
    if (name.toUpperCase() == userName.toUpperCase())
    {
      found = true;
      break;
    }
  }
  if (found)
  {
    this.userNameControl.Text = userInfo.name;
    this.pwdControl.Text = userInfo.password;
    this.aliasControl.Text = userInfo.alias;
    this.domainControl.Text = userInfo.domain;
  }
}

Options.prototype.onRemoveClicked = function(window, control)
{
  if (this.accountList.value.toUpperCase() == this.userNameControl.text.toUpperCase())
  {
     this.userNameControl.Text = "";
     this.pwdControl.Text = "";
     this.aliasControl.Text = "";
     this.domainControl.Text = "";
  }
  this.profile.removeAccount(this.accountList.value);
  this.updateAccountList();
}

Options.prototype.updateAccountList = function()
{
  var userNames = [];
  for (var i = 0; i < this.profile.userList.length; i++) {
    userNames[i] = this.profile.userList[i].name;
    if (this.profile.userList[i].domain != "")
      userNames[i] = userNames[i] + "@" + this.profile.userList[i].domain;
  }
  this.accountList.Text = userNames;
}

Options.prototype.addAccount = function()
{
   if (this.userNameControl.text != '') {
     this.profile.addUpdateAccount(this.userNameControl.Text, this.pwdControl.Text, 
       this.aliasControl.Text, this.domainControl.Text);
     this.userNameControl.Text = "";
     this.pwdControl.Text = "";
     this.aliasControl.Text = "";
     this.domainControl.Text = "";
     this.updateAccountList();
   }
}